---
title: WindowEventHandlers.onunload
slug: Web/API/WindowEventHandlers/onunload
tags:
  - API
  - Event Handler
  - MakeBrowserAgnostic
  - Property
  - Reference
  - WindowEventHandlers
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <strong><code>onunload</code></strong> property of the {{domxref("WindowEventHandlers")}} mixin is the {{domxref("EventHandler")}} for processing {{Event("unload")}} events. These events fire when the window is unloading its content and resources. The resource removal is processed <em>after</em> the <code>unload</code> event occurs.</p>

<div class="notecard note">
<p><strong>Note:</strong> Browsers equipped with pop-up blockers will ignore all {{domxref("Window.open()")}} method calls in <code>onunload</code> event handler functions.</p>
</div>

<div class="notecard warning">
<p>The <code>onunload</code> (and the <code><a href="/en-US/docs/Web/API/Window/unload_event">unload</a></code> event itself) are not the right features to use with <code><a href="/en-US/docs/Web/API/Navigator/sendBeacon">sendBeacon()</a></code>. Instead for <code><a href="/en-US/docs/Web/API/Navigator/sendBeacon">sendBeacon()</a>,</code> use the <code><a href="/en-US/docs/Web/API/Document/visibilitychange_event">visibilitychange</a></code> and <code><a href="/en-US/docs/Web/API/Window/pagehide_event">pagehide</a></code> events. See discussion comments in the blog post <a href="https://volument.com/blog/sendbeacon-is-broken#comments">Beacon API is broken</a>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">window.addEventListener("unload", function(event) { ... });
window.onunload = function(event) { ... };
</pre>

<p>Typically, it is better to use {{domxref("EventTarget.addEventListener", "window.addEventListener()")}} and the {{event("unload")}} event, instead of <code>onunload</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#handler-window-onunload', 'onunload')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', '#windoweventhandlers', 'GlobalEventHandlers')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5 W3C", "#windoweventhandlers", "GlobalEventHandlers")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WindowEventHandlers.onunload")}}</p>

<p>In Firefox 1.5, using this event handler in your page prevents the browser from caching the page in the in-memory bfcache. See <a href="/en-US/Firefox/Releases/1.5/Using_Firefox_1.5_caching">Using Firefox 1.5 caching</a> for details.</p>
